Load PlayList: { load.plist }
Save PlayList: { save.plist }
Delete PlayList:{ del.plist }
Set Main Dir:{ var %source = $sdir="Enter Main Source Dir" | hadd system main.mp3.source %source | echo -a %source set as main mp3 directory }
-
Add Dir:{ var %main = $hget(system,main.mp3.source) | var %source = $sdir(%main) | hadd system mp3source %source | mp3.list }
Add Song:{ var %source = $hget(system,mp3source) | var %song = $sfile(%source) | did -a jamp3 15 $remove($nopath(%song),.mp3) | aline @mp3.c.list $remove(%song,.mp3) }
-
Delete Song:{ get.new.list  }
Delete Listbox Contents:{ did -r jamp3 15 }
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;DIALOG EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
dialog jamp3 {
  title "Mp3 Player"
  size 140 35 104 143
  option dbu
  icon $dialog.icon , 0
  text "Progress Bar", 1, 3 4 69 8
  edit "", 2, 74 4 27 8, autohs center read
  edit "", 3, 3 16 98 8, autohs center read
  button "4", 4, 3 30 15 8
  button "<", 6, 19 30 15 8
  button ";", 7, 35 30 15 8
  button "9", 8, 51 30 15 8
  button ":", 9, 67 30 15 8
  button "6", 10, 83 30 18 8
  combo 11, 32 55 33 50, size drop
  text "PlayModes:", 12, 4 58 26 8
  button "1", 13, 70 43 15 8
  button "0", 14, 86 43 15 8
  list 15, 3 69 98 63, size
  button "+", 16, 84 57 8 8
  button "-", 17, 93 57 8 8
  text "PlayList(s):",18, 4 45 24 8
  combo 19, 32 42 33 50, size drop
  text "Vol:",20, 73 58 10 8
  button "?",21, 37 134 15 8
  button "X",22, 53 134 15 8 , cancel
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;COLOR ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias mp3.d.c.a {
  dll $mdx SetDialog $dname bgcolor $dialog.color
  dll $mdx SetColor 2,3,11,12,15,18,19,20 textbg $dialog.color
  dll $mdx SetColor 2,3,11,12,15,18,19,20 background $dialog.color
}
alias mp3.t.c.a {
  dll $mdx SetColor 2,3,4,5,6,7,8,9,10,12,13,14,15,16,17,18,20,21,22 text $text.color
}
alias mp3.el.c.a {
  dll $mdx SetColor 2,3,11,15,19 background $edit.list.color
  dll $mdx SetColor 2,3,11,15,19 textbg $edit.list.color 
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias popread { return $dll($+(",$scriptdirdlls/popread.dll,"),popread,$script? $$1 ? $$2 ? $calc($mouse.dx - 24) ? $mouse.dy ) }
alias update.pbar { if ( $dialog(jamp3).active == $true ) { did -ra jamp3 1 $int($calc($calc($insong.pos / 1000) / $calc($insong.length /  1000) * 100)) } }
alias jamp3 { if (!$dialog(jamp3)) { dialog -m jamp3 jamp3 } | else { dialog -ve jamp3 } }
alias set.mode {
  var %i = $did(11).text
  hadd system mp3play %i
}
alias mp3.list {
  var %source = $hget(system,mp3source)
  var %i = $findfile(%source,*.mp3,0,did -a jamp3 15 $remove($nopath($1-),.mp3))
}
alias set.mode {
  var %i = $did(jamp3,11).seltext
  hadd system mp3play %i
}
alias get.p.m {
  var %modes = single random cont repeat
  var %i = 1
  while ( $gettok(%modes,%i,32) ) {
    var %item = $ifmatch
    did -a jamp3 11 %item
    inc %i
  }
  if ( $hget(system,mp3play) == single ) { did -c jamp3 11 1 }
  elseif ( $hget(system,mp3play) == random ) { did -c jamp3 11 2 }
  elseif ( $hget(system,mp3play) == cont ) { did -c jamp3 11 3 }
  elseif ( $hget(system,mp3play) == repeat ) { did -c jamp3 11 4 }
}
alias mptime {
  if (!$insong) { return }
  var %x = $calc(($insong.length - $insong.pos) / 1000)
  var %tot = $gmt(%x,$iif(%x >= 3600,hh:nn:ss,nn:ss))
  if ($1 == mns) { return %tot } 
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;PLAY ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias playsong {
  var %song = $did(jamp3,15).seltext
  var %fullsong = $findfile($hget(system,main.mp3.source),%song $+ .mp3,1)
  if ( %fullsong = $null ) { echo -a ERROR: No song selected or no playlist loaded. Please check this and try again. }
  else { hadd system current.song %fullsong 
    splay -p %fullsong
    did -ra jamp3 3 $remove($nopath(%fullsong),.mp3) 
    did -ra jamp3 2 $mptime(mns)
    .timer1 0 1 update.pbar
  }
}
alias cont.play {
  var %pp = $did(jamp3,15).sel
  if (%pp == $did(jamp3,15).lines) { halt | echo -a You Have Reached The End Of Your PlayList }
  else { var %pp = $calc($did(jamp3,15).sel + 1) }
  did -c jamp3 15 %pp
  playsong
}
alias rand.play {
  did -c jamp3 15 $rand(1,$did(jamp3,15).lines)
  playsong
}
on *:MP3END:{ 
  .timer1 off 
  if ( $hget(system,mp3play) == random ) { rand.play }
  elseif ( $hget(system,mp3play) == cont ) { cont.play }
  elseif ( $hget(system,mp3play) == repeat ) { splay -p $hget(system,current.song) }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;PLAYLISTS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias save.plist {
  var %name =  $$?="Enter Playlist Name (No Spaces In Name)"
  if ( $chr(32) isin %name ) { echo -a ERROR: You have assigned a "space" within name of playlist. }
  elseif ( %name == $null ) { echo -a ERROR: No playlist name assigned. }
  else {
    var %filename = $+(",$scriptdirPlaylists\ $+ %name $+ .pl,")
    filter -ifc jamp3 15 %filename  
    .timerdelay 1 2 get.playlists
    echo -a SUCCESS: %name list was saved.
  }
}
alias load.plist {
  var %name = $did(jamp3,19).seltext
  if ( %name == $null ) { echo -a ERROR: No playlist selected. Please select a playlist and try again. }
  var %filename = $+(",$scriptdirPlaylists\ $+ %name $+ .pl,")
  did -r jamp3 15
  var %i = 1
  while ( $read(%filename,%i) ) {
    did -a jamp3 15 $v1
    inc %i
  }
}
alias get.new.list {
  var %i = $did(jamp3,15).sel 
  did -d jamp3 15 %i 
}
alias get.playlists {
  did -r jamp3 19
  var %pl = $findfile($+(",$scriptdirPlaylists,"),*.pl,0, did -a jamp3 19 $remove($nopath($1-),.pl))  
  did -c jamp3 19 $hget(system,playlist.sel)
}
alias del.plist {
  var %to.del = $did(jamp3,19).seltext
  var %file = $+(",$scriptdirPlaylists\ $+ %to.del $+ .pl,")
  remove -b %file
  .timerdelay 1 2 get.playlists
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;UP AND DOWN ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias mp3.down {
  var %pp = $did(jamp3,15).sel
  if (%pp == $did(jamp3,15).lines) { halt }
  else { var %pp = $calc($did(jamp3,15).sel + 1) }
  hadd system mp3.line %pp
  system.update
  did -c jamp3 15 %pp
  var %mp3.source = $hget(system,mp3source)
  var %mp3song = $did(jamp3,15).seltext
  did -ra jamp3 3 $remove(%mp3song,.mp3) 
}
alias mp3.up {
  var %pp = $did(jamp3,15).sel
  if (%pp == $did(jamp3,15).lines) { halt }
  else { var %pp = $calc($did(jamp3,15).sel - 1) }
  did -c jamp3 15 %pp
  hadd system mp3.line %pp
  var %mp3song = $did(jamp3,15).seltext
  system.update
  did -ra jamp3 3 $remove(%mp3song,.mp3) 
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;HELP ALIAS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias get.mp3.help {
  var %mp3.path = $remove($+(",$scriptdirHelp\Mp3 Player\mp3player-sb.htm,"),$chr(34))
  window -ak(0) @Help 
  echo @Help $dll($nHTMLn,attach,$window(@Help).hwnd) 
  echo @Help $dll($nHTMLn,navigate,%mp3.path) 
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;INIT EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamp3:init:0:{
  mdx.init
  if ( $hget(system,d.c) == on ) { mp3.d.c.a }
  if ( $hget(system,t.c) == on ) { mp3.t.c.a }
  if ( $hget(system,e.l.c) == on ) { mp3.el.c.a }
  dll $mdx SetControlMDX $dname 1 ProgressBar smooth > $scriptdirdlls\CTL_GEN.mdx
  if ( $hget(system,e.l.c) == on ) { did -a $dname 1 BGColor $edit.list.color }
  if ( $hget(system,t.c) == on ) { did -a $dname 1 BarColor $text.color }
  dll $mdx SetBorderStyle $dname 1,2,3,15 style $hget(system,border.style)
  dll $mdx SetBorderStyle $dname 4,6,7,8,9,10,13,14,16,17,21,22 style $hget(system,button.style)
  dll $mdx SetFont $dname 4,6,7,8,9,10 -9 400 Webdings
  dll $mdx SetFont $dname 13,14 -9 400 Wingdings
  dll $mdx SetFont $dname 2,11,12,15,18,19,20 -10 400 $gettok($hget(system,font.style),1,32)
  dll $mdx SetFont $dname 3 -9 500 Tahoma
  get.p.m
  get.playlists
  load.plist
  mp3.list
  if ( $insong.fname == $null ) { halt }
  else {
    did -ra jamp3 3 $remove($nopath($insong.fname),.mp3) 
    did -ra jamp3 2 $mptime(mns)
    .timer1 0 1 update.pbar
  }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;SCLICK EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamp3:sclick:*:{
  if ( $did == 4 ) { playsong }
  if ( $did == 6 ) { splay -p stop }
  if ( $did == 7 ) { if ( $hget(system,mp3mode) == pause ) { splay -p pause | hadd system mp3mode resume } | elseif ( $hget(system,mp3mode) == resume ) { splay -p resume | hadd system mp3mode pause } }
  if ( $did == 8 ) { mp3.up }
  if ( $did == 9 ) { mp3.down }
  if ( $did == 10 ) { if ( $hget(system,mp3size) == resize ) { dialog -sb jamp3 140 35 104 41 | hadd system mp3size sized } | elseif ( $hget(system,mp3size)  == sized ) { dialog -sb jamp3 140 35 104 143 | hadd system mp3size resize } } 
  if ( $did == 11 ) { set.mode }
  if ( $did == 13 ) { popread 4 10 }
  if ( $did == 14 ) { popread 1 3 }
  if ( $did == 16 ) { vol -v $calc($vol(master) + 2500) }
  if ( $did == 17 ) { vol -v $calc($vol(master) - 2500) }
  if ( $did == 19 ) { hadd system playlist.sel $did(jamp3,19).sel | system.update }
  if ( $did == 21 ) { get.mp3.help }
  if ( $did == 22 ) { window -c @help | .timer1 off | system.update }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;DCLICK EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamp3:dclick:15:{ playsong }
